#include <fstream>
#include <iostream>

#define MODE_R_ONLY 1
#define MODE_MATCH 2

using namespace std;

int compare(int key_num, int key_start_l[], int key_length[], int key_start_r[], const char* input_file_l, const char* input_file_r, int mode);
int compare_key(int key_num, string key_l[], string key_r[]);
void out_r_only(string str, int mode);
void out_match(string str, int mode);

int main(int argc, const char* argv[]) {
	if (argc < 7) {
		cout << endl;
		cout << "Usage: dup_key_diff key_start_l key_length input_file_l key_start_r input_file_r mode" << endl;
		cout << endl;
		cout << "mode" << endl;
		cout << "1:Ê݂ɑ݂L[̍s" << endl;
		cout << "2:ɃL[̓s݂E̍s" << endl;
		cout << endl;
		cout << "ex.: dup_key_diff 0 3 4 2 l.txt 7 14 r.txt 1" << endl;
		cout << "l.txt0Ԗڂ̕3L[A4Ԗڂ̕2L[ƂāA" << endl;
		cout << "r.txt7Ԗڂ̕3L[A14Ԗڂ̕2L[Ƃ" << endl;
		cout << "rAr.txt݂̂ɑ݂L[̍s؂o" << endl;
		cout << endl;
		cout << "" << endl;
		cout << "input_file_lEinput_file_r͋ɃL[ɊւďɐςƂ" << endl;
		cout << "L[̏d" << endl;
		cout << "L[̊Jnʒu̎w0n܂Ƃ" << endl;
		cout << "L[͌Œ蒷Ƃ" << endl;
		return 1;
	}
	int key_num = (argc - 4) / 3;
	int key_start_l[key_num];
	int key_length[key_num];
	int key_start_r[key_num];
	for (int i = 0; i < key_num; i++) {
		key_start_l[i] = atoi(argv[(i * 2) + 1]);
		key_length[i] = atoi(argv[(i * 2) + 2]);
		key_start_r[i] = atoi(argv[(key_num * 2) + 2 + i]);
	}
	
	return compare(key_num, key_start_l, key_length, key_start_r, argv[(key_num * 2) + 1], argv[argc - 2], atoi(argv[argc - 1]));
}

int compare(int key_num, int key_start_l[], int key_length[], int key_start_r[], const char* input_file_l, const char* input_file_r, int mode) {
	ifstream ifs_l(input_file_l);
	ifstream ifs_r(input_file_r);
	string buf_l, buf_r, key_l[key_num], key_r[key_num];
	string key_match[key_num];
	bool key_match_valid = false;
	bool read_l = false;
	bool read_r = false;
	int cmp_key_rslt;
	
	while (ifs_l && ifs_r) {
		if (!read_l) {
			read_l = getline(ifs_l, buf_l);
		}
		if (!read_r) {
			read_r = getline(ifs_r, buf_r);
		}
		if (read_l && !read_r) {
			break;
		} else if (!read_l && read_r) {
			while (read_r) {
				if (key_match_valid) {
					for (int i = 0; i < key_num; i++) {
						key_r[i] = buf_r.substr(key_start_r[i], key_length[i]);
					}
					cmp_key_rslt = compare_key(key_num, key_match, key_r);
				}
				if (key_match_valid && cmp_key_rslt == 0) {
					out_match(buf_r, mode);
				} else {
					out_r_only(buf_r, mode);
				}
				read_r = getline(ifs_r, buf_r);
			}
			break;
		} else if (!read_l && !read_r) {
			break;
		} else {
			for (int i = 0; i < key_num; i++) {
				key_l[i] = buf_l.substr(key_start_l[i], key_length[i]);
				key_r[i] = buf_r.substr(key_start_r[i], key_length[i]);
			}
			cmp_key_rslt = compare_key(key_num, key_l, key_r);
			
			if (cmp_key_rslt == 0) {
				out_match(buf_r, mode);
				for (int i = 0; i < key_num; i++) {
					key_match[i] = key_r[i];
				}
				key_match_valid = true;
				read_l = false;
				read_r = false;
			} else {
				if (key_match_valid && compare_key(key_num, key_match, key_r) == 0) {
					out_match(buf_r, mode);
					read_r = false;
				} else if (cmp_key_rslt < 0) {
					key_match_valid = false;
					read_l = false;
				} else if (cmp_key_rslt > 0) {
					out_r_only(buf_r, mode);
					key_match_valid = false;
					read_r = false;
				}
			}
		}
	}
	
	return 0;
}

int compare_key(int key_num, string key_l[], string key_r[]) {
	for (int i = 0; i < key_num; i++) {
		if (key_l[i] < key_r[i]) {
			return -1;
		} else if (key_l[i] > key_r[i]) {
			return 1;
		}
	}
	return 0;
}

void out_r_only(string str, int mode) {
	if (mode == MODE_R_ONLY) {
		cout << str << endl;
	}
}

void out_match(string str, int mode) {
	if (mode == MODE_MATCH) {
		cout << str << endl;
	}
}
